import string;
import regexp;
import c.stdio;
import console;

private
{
    template Pair(T)
    {
        struct Pair
        {
            T first, second;
        }
    }

    int find(char[] str, char c, int startPos)
    {
        while (startPos < str.length)
            if (str[startPos] == c)
                return startPos;
            else
                startPos++;
        return -1;
    }

    alias instance Pair(int).Pair IntPair;
}

class Formatter
{
    /*
        These are all case sensitive for now.

        {0} - the first element
        {3} - the fourth element

        None of this crap is implemented just yet.
        {8s} - The ninth element; throw an exception if it is not a string
        {2i} - Third element.  Throw if it is not an integer.
        {1f} - floating point.
        {4f5.2} - Floating point.  Five digits, two decimal places.
    */
    private
    {
        char[] _formatString;   // The string to parse and format.  We tweak this as we go.
        int _metaIndex;

        // TODO: return more information, like a desired type, and precision/padding.
        IntPair nextMetaString()
        {
            RegExp regex = new RegExp("\\{" ~ string.toString(_metaIndex) ~ "\\}", "g");

            IntPair pos;
            pos.second = -1;
            pos.first = regex.search(_formatString);
            if (pos.first != -1)
            {
                pos.second = find(_formatString, "}", pos.first);
            }

            delete regex; // Save the garbage collector the trouble.

            return pos;
        }

        void processMetaString(char[] str)
        {
            IntPair meta;
            do
            {
                meta = nextMetaString();
                if (meta.first == -1)
                    break;
                else
                    replace(meta, str);
            } while (true);

            _metaIndex++;
        }

        void replace(IntPair pos, char[] value)
        {
            _formatString =
                _formatString[0 .. pos.first] ~ value ~
                _formatString[(pos.second + 1) .. _formatString.length];
        }
    }

    public
    {
        this(char[] s)
        {
            _formatString = s;
            _metaIndex = 0;
        }

        char[] toString()
        {
            return _formatString;
        }

        Formatter reset(char[] str)
        {
            _formatString = str;
            _metaIndex = 0;
            return this;
        }

        Formatter mod(real r)
        {
            // ugh.  There has to be a better way.
            char[32] c;
            c[] = 0;
            sprintf(c, "%f", cast(double)r);

            processMetaString(string.toString(c));
            return this;
        }

        Formatter mod(int i)
        {
            processMetaString(string.toString(i));
            return this;
        }

        Formatter mod(char[] s)
        {
            processMetaString(s);
            return this;
        }

        Formatter mod(Object o)
        {
            processMetaString(o.toString());
            return this;
        }

        typedef int TerminatorType;
        static TerminatorType end;
        char[] mod(TerminatorType t)
        {
            return _formatString;
            // I'm tempted to 'delete this' as well.
        }

    }

    unittest
    {
        char[] str = "A string!";
        int i = 1337;
        real r = 3.141596;

        char[] result = new Formatter("TESTING{0}CRAP{1}FUN{2}WEE") % str % i % r % Formatter.end;
        assert(result == "TESTINGA string!CRAP1337FUN3.141596WEE");
    }
}

Formatter format(char[] str)
{
    // I see no way to do this without creating an object.
    // Using a single static instance raises threading issues
    return new Formatter(str);
}
